
#property indicator_separate_window
#property indicator_buffers    5
#property indicator_color1     LimeGreen
#property indicator_color2     Red
#property indicator_color3     Red
#property indicator_color4     DeepSkyBlue
#property indicator_color5     PaleVioletRed
#property indicator_width1     2
#property indicator_width2     2
#property indicator_width3     2
#property indicator_levelcolor MediumOrchid


//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    RsiPeriod       = 14;
extern int    Price           = PRICE_CLOSE;
extern string _rsimethods     = "0=rsi,1=wilder rsi,2=rsx,3=cuttler rsi ";
extern int    RsiMethod       = 0;
extern int    EMAPeriod       = 5;
extern int    ATRPeriod       = 14;
extern double K               = 4.236;
extern bool   Interpolate     = true;

extern double levelOb         = 80;
extern double levelOs         = 20;

extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern bool   alertsNotify    = false;
extern string soundFile       = "alert2.wav";

//
//
//
//
//

double RSIindex[];
double buffer4[];
double buffer5[];
double UpTrend[];
double DnTrend[];
double rsi[];
double smin[];
double smax[];
double trend[];
double slope[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

int init()
  {
   IndicatorBuffers(10);
   SetIndexBuffer(0,RSIindex); SetIndexLabel(0,"TrendRSI");
   SetIndexBuffer(1,buffer4);  SetIndexLabel(1,"TrendRSI");
   SetIndexBuffer(2,buffer5);  SetIndexLabel(2,"TrendRSI");
   SetIndexBuffer(3,UpTrend);  SetIndexLabel(3,"UpTrend"); 
   SetIndexBuffer(4,DnTrend);  SetIndexLabel(4,"DownTrend"); 
   SetIndexBuffer(5,rsi);
   SetIndexBuffer(6,smin);
   SetIndexBuffer(7,smax);
   SetIndexBuffer(8,trend);
   SetIndexBuffer(9,slope);

       //
       //
       //
       //
       //
         
       timeFrame         = stringToTimeFrame(TimeFrame);
       indicatorFileName = WindowExpertName();
       returnBars        = TimeFrame=="returnBars";       if (returnBars)     return(0);
       calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);

       //
       //
       //
       //   
       //
          
   SetLevelValue(0,levelOb);
   SetLevelValue(1,levelOs);
   IndicatorShortName(timeFrameToString(timeFrame)+"  Trend of "+getRsiName(RsiMethod)+" ("+RsiPeriod+","+EMAPeriod+","+ATRPeriod+","+DoubleToStr(K,3)+")");
  return(0);
}
int deinit() { return(0); }

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { RSIindex[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
     if (slope[limit] == -1) CleanPoint(limit,buffer4,buffer5);
     for (i=limit; i>=0; i--) rsi[i] = iRsi(getPrice(Price,i),RsiPeriod,i,0,RsiMethod);
     for (i=limit; i>=0; i--)
     {  
        RSIindex[i] = RSIindex[i+1]+2.0/(1.0+EMAPeriod)*(rsi[i]-RSIindex[i+1]);
        double AvgRange = 0; for (int x=0; x<ATRPeriod-1; x++) AvgRange += MathAbs(RSIindex[i+x]-RSIindex[i+x+1]); 
        double range    = AvgRange/ATRPeriod;
	     smax[i]    = RSIindex[i]+K*range; 
	     smin[i]    = RSIindex[i]-K*range;
	     buffer4[i] = EMPTY_VALUE;  
        buffer5[i] = EMPTY_VALUE; 
		  UpTrend[i] = EMPTY_VALUE;
        DnTrend[i] = EMPTY_VALUE;
	     trend[i]   = trend[i+1]; 
	     slope[i]   = slope[i+1];
	   
	     //
	     //
	     //
	     //
	     //
	   
	     if (RSIindex[i]>smax[i+1])     trend[i] = 1; 
	     if (RSIindex[i]<smin[i+1])     trend[i] =-1;
	     if (RSIindex[i]>RSIindex[i+1]) slope[i] = 1; 
	     if (RSIindex[i]<RSIindex[i+1]) slope[i] =-1; 
        if (trend[i]>0 && smin[i]<smin[i+1]) smin[i] = smin[i+1];
        if (trend[i]<0 && smax[i]>smax[i+1]) smax[i] = smax[i+1];
        if (trend[i] == 1) UpTrend[i] = smin[i]; 
	     if (trend[i] ==-1) DnTrend[i] = smax[i]; 
	     if (slope[i] ==-1) PlotPoint(i,buffer4,buffer5,RSIindex);
     }
     manageAlerts(); 
     return(0);
   }
   
   //
   //
   //
   //
   //
   
     limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
     if (slope[limit]==-1) CleanPoint(limit,buffer4,buffer5);
     for (i=limit;i>=0; i--)
     {
        int y = iBarShift(NULL,timeFrame,Time[i]);
         RSIindex[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiPeriod,Price,"",RsiMethod,EMAPeriod,ATRPeriod,K,0,y);
         buffer4[i]  = EMPTY_VALUE;
         buffer5[i]  = EMPTY_VALUE;
         UpTrend[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiPeriod,Price,"",RsiMethod,EMAPeriod,ATRPeriod,K,3,y);
         DnTrend[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiPeriod,Price,"",RsiMethod,EMAPeriod,ATRPeriod,K,4,y);
         trend[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiPeriod,Price,"",RsiMethod,EMAPeriod,ATRPeriod,K,8,y);
         slope[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiPeriod,Price,"",RsiMethod,EMAPeriod,ATRPeriod,K,9,y);
        
         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
               RSIindex[i+k] = RSIindex[i] + (RSIindex[i+n] - RSIindex[i]) * k/n;
               if (UpTrend[i]!=EMPTY_VALUE && UpTrend[i+n]!=EMPTY_VALUE) UpTrend[i+k] = UpTrend[i] + (UpTrend[i+n] - UpTrend[i]) * k/n;
               if (DnTrend[i]!=EMPTY_VALUE && DnTrend[i+n]!=EMPTY_VALUE) DnTrend[i+k] = DnTrend[i] + (DnTrend[i+n] - DnTrend[i]) * k/n;
            }
   }
   for (i=limit;i>=0;i--) if (slope[i]==-1) PlotPoint(i,buffer4,buffer5,RSIindex);
   manageAlerts();
return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
//

double getPrice(int type, int i)
{
   switch (type)
   {
      case 7:     return((Open[i]+Close[i])/2.0);
      case 8:     return((Open[i]+High[i]+Low[i]+Close[i])/4.0);
      default :   return(iMA(NULL,0,1,0,MODE_SMA,type,i));
   }      
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
//

string rsiMethodNames[] = {"rsi","wilders rsi","rsx","cuttler rsi"};
string getRsiName(int& method)
{
   int max = ArraySize(rsiMethodNames)-1;
      method=MathMax(MathMin(method,max),0); return(rsiMethodNames[method]);
}

//
//
//
//
//

double workRsi[][13];
#define _price  0
#define _change 1
#define _changa 2

double iRsi(double price, double period, int i, int instanceNo=0, int rsiMode=0)
{
   if (ArrayRange(workRsi,0)!=Bars) ArrayResize(workRsi,Bars);
      int z = instanceNo*13; 
      int r = Bars-i-1;
   
   //
   //
   //
   //
   //
   
   workRsi[r][z+_price] = price;
   switch (rsiMode)
   {
      case 0:
         double alpha = 1.0/period; 
         if (r<period)
            {
               int k; double sum = 0; for (k=0; k<period && (r-k-1)>=0; k++) sum += MathAbs(workRsi[r-k][z+_price]-workRsi[r-k-1][z+_price]);
                  workRsi[r][z+_change] = (workRsi[r][z+_price]-workRsi[0][z+_price])/MathMax(k,1);
                  workRsi[r][z+_changa] =                                         sum/MathMax(k,1);
            }
         else
            {
               double change = workRsi[r][z+_price]-workRsi[r-1][z+_price];
                               workRsi[r][z+_change] = workRsi[r-1][z+_change] + alpha*(        change  - workRsi[r-1][z+_change]);
                               workRsi[r][z+_changa] = workRsi[r-1][z+_changa] + alpha*(MathAbs(change) - workRsi[r-1][z+_changa]);
            }
         if (workRsi[r][z+_changa] != 0)
               return(50.0*(workRsi[r][z+_change]/workRsi[r][z+_changa]+1));
         else  return(50.0);
         
      //
      //
      //
      //
      //
      
      case 1 :
         workRsi[r][z+1] = iSmma(0.5*(MathAbs(workRsi[r][z+_price]-workRsi[r-1][z+_price])+(workRsi[r][z+_price]-workRsi[r-1][z+_price])),0.5*(period-1),Bars-i-1,0);
         workRsi[r][z+2] = iSmma(0.5*(MathAbs(workRsi[r][z+_price]-workRsi[r-1][z+_price])-(workRsi[r][z+_price]-workRsi[r-1][z+_price])),0.5*(period-1),Bars-i-1,1);
         if((workRsi[r][z+1] + workRsi[r][z+2]) != 0) 
               return(100.0 * workRsi[r][z+1]/(workRsi[r][z+1] + workRsi[r][z+2]));
         else  return(50);

      //
      //
      //
      //
      //

      case 2 :     
         double Kg = (3.0)/(2.0+period), Hg = 1.0-Kg;
         if (r<period) { for (k=1; k<13; k++) workRsi[r][k+z] = 0; return(50); }  

         //
         //
         //
         //
         //
      
         double mom = workRsi[r][_price+z]-workRsi[r-1][_price+z];
         double moa = MathAbs(mom);
         for (k=0; k<3; k++)
         {
            int kk = k*2;
            workRsi[r][z+kk+1] = Kg*mom                + Hg*workRsi[r-1][z+kk+1];
            workRsi[r][z+kk+2] = Kg*workRsi[r][z+kk+1] + Hg*workRsi[r-1][z+kk+2]; mom = 1.5*workRsi[r][z+kk+1] - 0.5 * workRsi[r][z+kk+2];
            workRsi[r][z+kk+7] = Kg*moa                + Hg*workRsi[r-1][z+kk+7];
            workRsi[r][z+kk+8] = Kg*workRsi[r][z+kk+7] + Hg*workRsi[r-1][z+kk+8]; moa = 1.5*workRsi[r][z+kk+7] - 0.5 * workRsi[r][z+kk+8];
         }
         if (moa != 0)
              return(MathMax(MathMin((mom/moa+1.0)*50.0,100.00),0.00)); 
         else return(50);
            
      //
      //
      //
      //
      //
      
      case 3 :
         double sump = 0;
         double sumn = 0;
         for (k=0; k<period; k++)
         {
            double diff = workRsi[r-k][z+_price]-workRsi[r-k-1][z+_price];
               if (diff > 0) sump += diff;
               if (diff < 0) sumn -= diff;
         }
         if (sumn > 0)
               return(100.0-100.0/(1.0+sump/sumn));
         else  return(50);
   }
   return(0); 
}

//
//
//
//
//
//

double workSmma[][2];
double iSmma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workSmma,0)!= Bars) ArrayResize(workSmma,Bars);

   //
   //
   //
   //
   //

   if (r<period)
         workSmma[r][instanceNo] = price;
   else  workSmma[r][instanceNo] = workSmma[r-1][instanceNo]+(price-workSmma[r-1][instanceNo])/period;
   return(workSmma[r][instanceNo]);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i]   = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"up trend");
         if (trend[whichBar] ==-1) doAlert(whichBar,"down trend");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" TrendRSI ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," TrendRSI "),message);
          if (alertsSound)   PlaySound(soundFile);
   }
}


